class Game {

    constructor(canvas) {

        this.canvas = canvas;

        // Create menu
        let menu = new Menu(canvas);

        // Create game scene
        let box = new Box();
        this.scene = new Scene(document.getElementById('canvas'), box);

        this.changeScreen(menu);
    }

    changeScreen(screen) {
        if (this.mainSCreen !== undefined) {
            this.mainScreen.removeListeners();
        }

        this.mainScreen = screen;
        screen.status = Status.Running;
        screen.addListeners();
    }

    update(time = 0.02) {
        this.mainScreen.update(time);

        if (this.mainScreen.status === Status.Finished) {
            if (this.mainScreen.after === AfterMenu.Start) {
                this.changeScreen(this.scene);
            } else if (this.mainScreen.after === AfterMenu.Exit) {
                if (navigator.app !== undefined && typeof navigator.app.exitApp === 'function') {
                    navigator.app.exitApp();
                }
            }
        }
    }

    render() {
        this.autoResize();
        this.mainScreen.render();
    }

    autoResize() {
        this.canvas.width = window.innerWidth;
        this.canvas.height = window.innerHeight;
    }
}
